
#pragma hdrstop
#include <condefs.h>


//---------------------------------------------------------------------------
#pragma argsused
#include <iostream>
#include <fstream>
#include <sstream>
#include <stdio.h>

using namespace std;


struct	rozsah {
		int max_x;
        int max_y;
        int min_x;
        int min_y;
	     };

const width = 800;
const height = 600;             

double foo (std::string const & s)
{
  std::istringstream iss (s);
  double val;
  iss >> val;
  return val;
}


void get_line(string a,ifstream& vstup,ofstream& vystup)
{
 vstup>>a;
 vystup<<"x"<<endl;
 while (a[0]!='&')
 {
  if (a=="P")
  {
   vstup>>a;
   vystup<<a<<" ";
   vstup>>a;
   vystup<<a<<endl;
  }
  if (a=="L")
  {
   vstup>>a;
   vystup<<a<<" ";
   vstup>>a;
   vystup<<a<<endl;
  }
  vstup>>a;
 }
}

void get_class(ifstream& vstup2,ofstream& vystup2)
{
 string b;
 vstup2>>b; /* nacteni 1. x */
 int z;
 int p=1;
 while (vstup2)
 {
  vstup2>>b;
  p++;
  z = p;
  while ((b!="x") && (vstup2))
  {
   vstup2>>b;
   p++;
  }
  if (p-z == 2) vystup2<<"P"<<endl;
  if (p-z == 4) vystup2<<"L"<<endl;
  if (p-z > 4) vystup2<<"M "<<(p-z)/2<<endl;
 }
}


struct rozsah get_viewbox(ifstream& vstup3)
{
 string c;
 rozsah mm;
 long hodnota;
 vstup3>>c;
 vstup3>>c;
 hodnota = foo (c);
 mm.max_x = hodnota;
 mm.min_x = hodnota;
 vstup3>>c;
 hodnota = foo (c);
 mm.max_y = hodnota;
 mm.min_y = hodnota;

 while (vstup3)
 {
  vstup3>>c;

  while ((c!="x") && (vstup3))
  {
   hodnota = foo (c);
   if (hodnota > mm.max_x) mm.max_x = hodnota;
   if (hodnota < mm.min_x) mm.min_x = hodnota;
   vstup3>>c;
   hodnota = foo (c);
   if (hodnota > mm.max_y) mm.max_y = hodnota;
   if (hodnota < mm.min_y) mm.min_y = hodnota;
   vstup3>>c;
  }

 }
 return mm;
}

double get_scale(struct rozsah viewbox)
{
 double delka_m = 1;
 double r = viewbox.max_x - viewbox.min_x;
 while (delka_m < (r/20))
 {
  delka_m = delka_m * 5;
 }
return delka_m;
}


void create_svg(ifstream& data,ifstream& tridy,ofstream& vypis,struct rozsah viewbox,double delka_m)
{
 vypis.setf (ios::fixed);
 vypis.precision (2);
 double rx = viewbox.max_x - viewbox.min_x;
 double ry = viewbox.max_y - viewbox.min_y;
 vypis<<"<?xml version=\"1.0\" standalone=\"no\"?>"<<endl;
 vypis<<"<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\""<<endl;
 vypis<<"\"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\">"<<endl;
 vypis<<"<svg width=\""<<width<<"px\" height=\""<<height<<"px\" version=\"1.1\""<<endl;
 vypis<<"viewBox=\"";
 vypis<<"0"<<" "<<"0"<<" "<<rx + rx/100<<" "<<ry + ry/10;
 vypis<<"\" preserveAspectRatio=\"none\""<<endl;
 vypis<<"xmlns=\"http://www.w3.org/2000/svg\">"<<endl;
/* vypis<<"<g transform=\"rotate(-90)\">"<<endl; */
 string d;
 int p;
 double dd;
 data>>d;
 tridy>>d;
 while (tridy)
 {
  if (d=="L")
  {
   vypis<<"<line x1=\"";
   data>>dd;
   vypis<<viewbox.max_x - dd;
   vypis<<"\" y1=\"";
   data>>dd;
   vypis<<dd - viewbox.min_y;
   vypis<<"\" x2=\"";
   data>>dd;
   vypis<<viewbox.max_x - dd;
   vypis<<"\" y2=\"";
   data>>dd;
   vypis<<dd - viewbox.min_y;
   vypis<<"\" stroke-width=\"2\" stroke=\"black\"/>"<<endl;
  }
  if (d=="M")
  {
   tridy>>p;
   vypis<<"<polyline fill=\"none\" ";
   vypis<<"stroke=\"black\" stroke-width=\"2\" points=\"";
   for (int j=0; j<p; j++)
   {
    data>>dd;
    vypis<<" "<<viewbox.max_x - dd;
    data>>dd;
    vypis<<" "<<dd - viewbox.min_y;
   }
   vypis<<"\"/>"<<endl;
  }

  if (d=="P")
  {
   data>>d;
   data>>d;
  }

  data>>d;
  tridy>>d;
 }
 /*vypis<<"</g>"<<endl; */
 vypis<<"<line x1=\""<<rx - rx/20<<"\" y1=\"";
 vypis<<ry + ry/15<<"\" x2=\"";
 vypis<<rx - rx/20 - delka_m<<"\" y2=\"";
 vypis<<ry + ry/15;
 vypis<<"\" stroke-width=\"5\" stroke=\"black\"/>"<<endl;
 vypis<<"<text x=\""<<rx - rx/20 - delka_m<<"\" y=\""<<ry  + ry/20;
 vypis<<"\" font-family=\"Helvetica\" font-size=\""<<ry/50<<"\" font-style=\"italic\" fill=\"black\" >";
 vypis.precision (0);
 vypis<<delka_m<<" m</text>"<<endl;

 vypis<<"<line x1=\""<<rx/20<<"\" y1=\"";
 vypis<<ry + ry/15<<"\" x2=\"";
 vypis<<rx/10<<"\" y2=\"";
 vypis<<ry + ry/15;
 vypis<<"\" stroke-width=\"5\" stroke=\"black\"/>"<<endl;

 vypis<<"<line x1=\""<<rx/20<<"\" y1=\"";
 vypis<<ry + ry/15<<"\" x2=\"";
 vypis<<rx/13<<"\" y2=\"";
 vypis<<ry + ry/15 - ry/100;
 vypis<<"\" stroke-width=\"5\" stroke=\"black\"/>"<<endl;

 vypis<<"<line x1=\""<<rx/20<<"\" y1=\"";
 vypis<<ry + ry/15<<"\" x2=\"";
 vypis<<rx/13<<"\" y2=\"";
 vypis<<ry + ry/15 + ry/100;
 vypis<<"\" stroke-width=\"5\" stroke=\"black\"/>"<<endl;

 vypis<<"<text x=\""<<rx/9<<"\" y=\""<<ry  + ry/15;
 vypis<<"\" font-family=\"Helvetica\" font-size=\""<<ry/40<<"\" font-style=\"italic\" fill=\"black\" >";
 vypis<<"S</text>"<<endl;
 vypis<<"</svg>";
}
/* ry/40 */



int main(int argc, char* argv[])
{
char n[100];
cout<<"Zadej nazev souboru: ";
cin>>n;
string a;
ifstream vstup(n);
if (!vstup) {
cout<<"!!! Vstupni soubor neexistuje !!!";
getchar();
return 0;
}
cout<<"Pracuji...";
int p = strlen(n);
n[p-3] = 'd';
n[p-2] = 'a';
n[p-1] = 't';
ofstream vystup(n);
vstup>>a;
while (vstup)
{
 if (a=="&L") get_line(a,vstup,vystup); /* Vype kresebn prvky do vlastnho datovho souboru */
 vstup>>a;
}

ifstream vstup2(n);
n[p-3] = 't';
n[p-2] = 'r';
n[p-1] = 'd';
ofstream vystup2(n);
get_class(vstup2,vystup2); /*  Kategorizace (P - point, L - line, M - polyline) */

rozsah viewbox;
n[p-3] = 'd';
n[p-2] = 'a';
n[p-1] = 't';
ifstream vstup3(n);
viewbox = get_viewbox(vstup3); /* Zjitn rozsahu souboru - meze souadnic */

double delka_m;
delka_m = get_scale(viewbox); /*  Uren optimln dlky  grafickho mtka */

ifstream data(n);
n[p-3] = 't';
n[p-2] = 'r';
n[p-1] = 'd';
ifstream tridy(n);
n[p-3] = 's';
n[p-2] = 'v';
n[p-1] = 'g';
ofstream vypis(n);
create_svg(data,tridy,vypis,viewbox,delka_m); /*  Tvorba SVG souboru */

/*getchar();*/
return 0;

}
